from Products.TrafficQuotaFolder.TrafficQuotaFolder import TrafficQuotaFolder, TrafficQuotaFolderAddForm, manage_addTrafficQuotaFolder
from zLOG import LOG, INFO
import ZPublisher

def publish(request, module_name, after_list, debug=0, call_object=ZPublisher.Publish.call_object, missing_name=ZPublisher.Publish.missing_name, dont_publish_class=ZPublisher.Publish.dont_publish_class, mapply=ZPublisher.Publish.mapply,):
    "New Publish-Method. Makes Parent object of published object Traffic-Aware"
    response = ZPublisher.Publish.publish_old(request, module_name, after_list, debug, call_object, missing_name, dont_publish_class, mapply,)

    for parent in request['PARENTS']:
      try:
        doregister = isinstance(parent, TrafficQuotaFolder)
      except TypeError: #Catches rare cases where parent is a Class or Module itself instead of an Instance of a class (i.e. for /p_/icon.gif Icons -> p_ is a Class, not an Instance)
        doregister = 0
      if (doregister):
        #Measuring Length of Form-Data --> kind of akward. Better simply get length of HTTP/FTP REQUEST. Any ideas how?
        pos = request.stdin.tell()
        request.stdin.seek(0)
        requestlen = len(request.stdin.read())
        request.stdin.seek(pos)
        #Register produced tarffic. Two know bugs 1: Only hanldes HTTP RESPONSES Corrently 2: how does one account for incomplete outputs (ie cancelled downloads)?
        responselen = len(str(response))
        parent.register_traffic(requestlen + responselen) #will throw an exception if quota is exceeded
    return response


#Apply patch to publish to make it Traffic Aware
if (getattr(ZPublisher.Publish,'TrafficQuotaFolderApplied', None) is None):
  LOG('TrafficQuotaProduct', INFO, 'Server Restart: Patching Publish Method for appliance of TrafficQuotaFolder')
  ZPublisher.Publish.publish_old = ZPublisher.Publish.publish
  ZPublisher.Publish.TrafficQuotaFolderApplied = 1

else:
  LOG('TrafficQuotaProduct', INFO, 'Product Refresh: Publish Method already patched')
ZPublisher.Publish.publish = publish


def initialize(self):
  self.registerClass(TrafficQuotaFolder, constructors = (TrafficQuotaFolderAddForm, manage_addTrafficQuotaFolder), icon = 'www/TrafficQuota.gif')
  #self.registerBaseClass(TrafficQuotaFolder)

